package com.zt.plat.module.qms.business.config.service;

import cn.hutool.core.collection.CollUtil;
import com.zt.plat.module.qms.business.config.controller.vo.MaterialAssayStandardPageReqVO;
import com.zt.plat.module.qms.business.config.controller.vo.MaterialAssayStandardRespVO;
import com.zt.plat.module.qms.business.config.controller.vo.MaterialAssayStandardSaveReqVO;
import com.zt.plat.module.qms.business.config.dal.dataobject.MaterialAssayStandardExtendDO;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.springframework.stereotype.Service;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;

import java.util.*;

import com.zt.plat.module.qms.business.config.dal.dataobject.MaterialAssayStandardDO;
import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.common.util.object.BeanUtils;

import com.zt.plat.module.qms.business.config.dal.mapper.MaterialAssayStandardMapper;

import static com.zt.plat.framework.common.exception.util.ServiceExceptionUtil.exception;
import static com.zt.plat.framework.common.util.collection.CollectionUtils.convertList;
import static com.zt.plat.module.qms.enums.ErrorCodeConstants.MATERIAL_ASSAY_STANDARD_NOT_EXISTS;

/**
 * 物料检测标准 Service 实现类
 *
 * @author 后台管理
 */
@Service
@Validated
public class MaterialAssayStandardServiceImpl implements MaterialAssayStandardService {



    @Resource private MaterialAssayStandardMapper materialAssayStandardMapper;

    @Override
    public List<MaterialAssayStandardDO> queryByBaseSampleID(Long baseSampleID) {
        LambdaQueryWrapper<MaterialAssayStandardDO> query = new LambdaQueryWrapper<>();
        query.eq(MaterialAssayStandardDO::getBaseSampleId, baseSampleID);
        return materialAssayStandardMapper.selectList(query);
    }

    @Override
    public MaterialAssayStandardRespVO createMaterialAssayStandard(MaterialAssayStandardSaveReqVO createReqVO) {
        // 插入
        MaterialAssayStandardDO materialAssayStandard = BeanUtils.toBean(createReqVO, MaterialAssayStandardDO.class);
        materialAssayStandardMapper.insert(materialAssayStandard);
        // 返回
        return BeanUtils.toBean(materialAssayStandard, MaterialAssayStandardRespVO.class);
    }

    @Override
    public void updateMaterialAssayStandard(MaterialAssayStandardSaveReqVO updateReqVO) {
        // 校验存在
        validateMaterialAssayStandardExists(updateReqVO.getId());
        // 更新
        MaterialAssayStandardDO updateObj = BeanUtils.toBean(updateReqVO, MaterialAssayStandardDO.class);
        materialAssayStandardMapper.updateById(updateObj);
    }

    @Override
    public void deleteMaterialAssayStandard(Long id) {
        // 校验存在
        validateMaterialAssayStandardExists(id);
        // 删除
        materialAssayStandardMapper.deleteById(id);
    }

    @Override
        public void deleteMaterialAssayStandardListByIds(List<Long> ids) {
        // 校验存在
        validateMaterialAssayStandardExists(ids);
        // 删除
        materialAssayStandardMapper.deleteByIds(ids);
        }

    private void validateMaterialAssayStandardExists(List<Long> ids) {
        List<MaterialAssayStandardDO> list = materialAssayStandardMapper.selectByIds(ids);
        if (CollUtil.isEmpty(list) || list.size() != ids.size()) {
            throw exception(MATERIAL_ASSAY_STANDARD_NOT_EXISTS);
        }
    }

    private void validateMaterialAssayStandardExists(Long id) {
        if (materialAssayStandardMapper.selectById(id) == null) {
            throw exception(MATERIAL_ASSAY_STANDARD_NOT_EXISTS);
        }
    }

    @Override
    public MaterialAssayStandardDO getMaterialAssayStandard(Long id) {
        return materialAssayStandardMapper.selectById(id);
    }

    @Override
    public PageResult<MaterialAssayStandardDO> getMaterialAssayStandardPage(MaterialAssayStandardPageReqVO pageReqVO) {
        return materialAssayStandardMapper.selectPage(pageReqVO);
    }

    @Override
    public PageResult<MaterialAssayStandardExtendDO> getMaterialAssayStandardPageWithExtend(MaterialAssayStandardPageReqVO pageReqVO) {
        IPage<MaterialAssayStandardExtendDO> page = new Page<>(pageReqVO.getPageNo(), pageReqVO.getPageSize());
        Page<MaterialAssayStandardExtendDO> pageList = materialAssayStandardMapper.selectPageWithExtend(page, pageReqVO);
        PageResult<MaterialAssayStandardExtendDO> ret = new PageResult<>(pageList.getRecords(), pageList.getTotal());
        return ret;
    }
}